import java.awt.geom.Point2D as Point2D
import java.awt.geom.Rectangle2D as Rectangle2D
import sys

from gvsiglib import *

mapContext = None

def getMapContext():

	view = gvSIG.getActiveDocument()
	if view == None:
		print "Active document can not be accessed."
		return None
	try:
		print "view= %s dir=%s"%(repr(view), dir(view))
		mapContext = view.getModel().getMapContext()
	
	except Exception, e:
		print "Active document is not a view."
		print "Error %s %s" % (str(e.__class__),str(e))
		return None
	
	return mapContext

mapContext = getMapContext()

def clickApply(thinlet):

	global mapContext

	if mapContext == None:
		print "Active document can not be accessed."
		return
		
	if mapContext.getLayers().getLayersCount() < 1:
		print "No layers in active document."
		return
	x = float(thinlet.getString(txtX, "text"))
	y = float(thinlet.getString(txtY, "text"))
	center = zoomToCoordinates(mapContext, x,y)
	drawPoint(mapContext,center)
	
def zoomToCoordinates(mapContext, x,y):
	try:
		oldExtent = mapContext.getViewPort().getAdjustedExtent()
		oldCenterX = oldExtent.getCenterX()
		oldCenterY = oldExtent.getCenterY()
		center=Point2D.Double(x,y)
		movX = x-oldCenterX
		movY = y-oldCenterY
		upperLeftCornerX = oldExtent.getMinX()+movX
		upperLeftCornerY = oldExtent.getMinY()+movY
		width = oldExtent.getWidth()
		height = oldExtent.getHeight()
		extent = Rectangle2D.Double(upperLeftCornerX, upperLeftCornerY, width, height)
		mapContext.getViewPort().setExtent(extent)
		return center
	except ValueError, e:
		print "Error when zooming to coordinates (%s,%s). Error %s, %s" % (
		repr(x),
		repr(y),
		str(e.__class__),
		str(e))
		return None
		
def drawPoint(mapContext, center, color=None):
	"""
	This function draws a point on the mapcontext graphic layer.
	"""
	if color == None:
		import java.awt.Color as Color
		color = Color.blue
	
	layer=mapContext.getGraphicsLayer()
	layer.clearAllGraphics()
	theSymbol = FSymbol(FConstant.SYMBOL_TYPE_POINT,color)
	idSymbol = layer.addSymbol(theSymbol)
	geom = ShapeFactory.createPoint2D(center.getX(),center.getY())
	theGraphic = FGraphic(geom, idSymbol)
	layer.addGraphic(theGraphic)
	
def isValidView():

	global mapContext
	
	if mapContext.getLayers().getLayersCount() < 1:
		print "No layers in active document."
		return False
	return True

if isValidView():
	thinlet.setBoolean(botApply,"enabled",True)
else:
	thinlet.setBoolean(botApply,"enabled",False)
